import { EOChildren } from 'mve-core/childrenBuilder';
import { DOMNode } from './index';
/**
 * 简单的tsx支撑
 * 如在tsconfig中配置
        "jsx": "react",
        "jsxFactory":"createElement",
 * 需要的地方导入
        import { createElement,Dom,Fragment,JSX, Svg, SvgFragment } from 'mve-dom/jsxSupport'
 * 可能需要全局导入
        declare namespace JSX {
            type IntrinsicElements=import("mve-dom/jsxSupport").JSX.IntrinsicElements
            type Element=import("mve-dom/jsxSupport").JSX.Element
            type ElementChildrenAttribute=import('mve-dom/jsxSupport').JSX.ElementChildrenAttribute
        }
 */
export declare function createElement<A extends (...vs: any[]) => any>(type: A, ...vs: Parameters<A>): ReturnType<A>;
export declare type TsxChildren = string | number | boolean | EOChildren<Node> | TsxChildren[];
export interface DOMTsxProp extends Omit<DOMNode, 'children'> {
    children?: TsxChildren;
}
export declare function Dom(props: DOMTsxProp, ...children: TsxChildren[]): import("mve-core/childrenBuilder").EOChildFun<Node>;
export declare function fromTsxChildren(children: TsxChildren): Node | import("mve-core/childrenBuilder").ChildLife | import("mve-core/childrenBuilder").EOChildFun<Node> | EOChildren<Node>[];
export declare function mergeFromTsxChildren(childrenA: TsxChildren | void, childrenB: TsxChildren[]): Node | import("mve-core/childrenBuilder").ChildLife | import("mve-core/childrenBuilder").EOChildFun<Node> | EOChildren<Node>[];
export declare function Fragment(prop?: {
    children?: TsxChildren;
}, ...children: TsxChildren[]): Node | import("mve-core/childrenBuilder").ChildLife | import("mve-core/childrenBuilder").EOChildFun<Node> | EOChildren<Node>[];
export declare function Svg(props: DOMNode, ...children: EOChildren<Node>[]): import("mve-core/childrenBuilder").EOChildFun<Node>;
export declare function mergeFromEOChildren(childrenA: EOChildren<Node> | void, childrenB: EOChildren<Node>[]): EOChildren<Node>[];
export declare function SvgFragment(props?: {
    children?: EOChildren<Node>;
}, ...children: EOChildren<Node>[]): EOChildren<Node>[];
export declare namespace JSX {
    /**禁止所有内建小写元素 */
    interface IntrinsicElements {
    }
    /**与mve-core核心类型的兼容性 */
    type Element = EOChildren<Node>;
    /**
     * TSX内容元素类型，需要先声明
     */
    interface ElementChildrenAttribute {
        children: any;
    }
}
